﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataTreeContextMenu
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Data = new ContinentCollection();
            DataContext = this;
        }
        public ObservableCollection<MyNode> Data { get; set; }
    }
    #region Data

    public class ContinentCollection : ObservableCollection<MyNode>
    {
        public ContinentCollection()
        {
            Add(
                new MyNode
                {
                    Name = "Africa",
                    MyNodes = new ObservableCollection<MyNode>()
                    {
                        new MyNode()
                        {
                            Name = "Algeria",
                            MyNodes = new ObservableCollection<MyNode>()
                            {
                                new MyNode {Name = "Algiers"},
                                new MyNode {Name = "Oran"},
                            }
                        },
                        new MyNode()
                        {
                            Name = "Angola",
                            MyNodes = new ObservableCollection<MyNode>()
                            {
                                new MyNode {Name = "Soyo"},
                                new MyNode {Name = "Ndalatando"},
                                new MyNode {Name = "Ambriz"},
                            }
                        },
                        new MyNode()
                        {
                            Name = "Cape Verde",
                            MyNodes = new ObservableCollection<MyNode>()
                            {
                                new MyNode {Name = "Mindelo"},
                                new MyNode {Name = "Assomada"},
                            }
                        }
                    }
                });

            Add(
                new MyNode
                {
                    Name = "Asia",
                    MyNodes = new ObservableCollection<MyNode>()
                                    {
                                        new MyNode()
                                        {
                                            Name = "Cambodia",
                                            MyNodes = new ObservableCollection<MyNode>()
                                            {
                                                new MyNode {Name = "Phnom Penh"},
                                                new MyNode {Name = "Koh Kong"},
                                            }
                                        },
                                        new MyNode()
                                        {
                                            Name = "China",
                                            MyNodes = new ObservableCollection<MyNode>()
                                            {
                                                new MyNode {Name = "Shanghai"},
                                                new MyNode {Name = "Beijing"},
                                                new MyNode {Name = "Tianjin"},
                                            }
                                        },
                                        new MyNode()
                                        {
                                            Name = "Japan",
                                            MyNodes = new ObservableCollection<MyNode>()
                                            {
                                                new MyNode {Name = "Tokyo"},
                                                new MyNode {Name = "Yokohama"},
                                                new MyNode {Name = "Sapporo"},
                                            }
                                        }
                                    }
                });

            Add(new MyNode
            {
                Name = "Australia",
                MyNodes = new ObservableCollection<MyNode>()
                                    {
                                        new MyNode()
                                        {
                                            Name = "Australia",
                                            MyNodes = new ObservableCollection<MyNode>()
                                            {
                                                new MyNode {Name = "Sydney"},
                                                new MyNode {Name = "Melbourne"},
                                                new MyNode {Name = "Perth"},
                                            }
                                        }
                                    }
            });

            Add(new MyNode
            {
                Name = "Europe",
                MyNodes = new ObservableCollection<MyNode>()
                                    {
                                        new MyNode()
                                        {
                                            Name = "Germany",
                                            MyNodes = new ObservableCollection<MyNode>()
                                            {
                                                new MyNode {Name = "Berlin"},
                                                new MyNode {Name = "Hamburg"}
                                            }
                                        },
                                        new MyNode()
                                        {
                                            Name = "Italy",
                                            MyNodes = new ObservableCollection<MyNode>()
                                            {
                                                new MyNode {Name = "Milan"},
                                                new MyNode {Name = "Naples"},
                                                new MyNode {Name = "Rome"}
                                            }
                                        }
                                    }
            });
        }
    }

    public class MyNode
    {
        public string Name { get; set; }
        public ObservableCollection<MyNode> MyNodes { get; set; }
    }

    #endregion
}
